<template>
  <div>
    <v-navigation-drawer
      v-if="isAuth"
      v-model="drawer"
      app
      src="@/assets/images/library.jpeg"
      :width="230"
      :dark="barColor !== 'rgba(228, 226, 226, 1), rgba(255, 255, 255, 0.7)'"
    >
      <template #img="props">
        <v-img
          :gradient="`to bottom, ${barColor}`"
          v-bind="props"
        />
      </template>

      <v-list
        dense
        nav
      >
        <v-list-item lass="ma-0 pa-0">
          <v-list-item-avatar
            class="align-self-center"
            contain
            tile
          >
            <v-img src="@/assets/images/svg/books_icon.svg" />
          </v-list-item-avatar>

          <v-list-item-content>
            <v-list-item-title
              class="text-h6"
            >
              TAMS
            </v-list-item-title>
            <v-list-item-subtitle class="caption font-italic text-uppercase">
              {{ authUser.level }}
            </v-list-item-subtitle>
          </v-list-item-content>
        </v-list-item>
      </v-list>

      <v-divider class="mb-2" />

      <v-list
        dense
        nav
      >
        <div
          v-for="(route, key) in routes"
          :key="key"
        >
          <v-list-item
            v-if="!route.sub"
            link
            :to="route.to"
          >
            <v-list-item-action>
              <v-icon v-text="route.icon" />
            </v-list-item-action>

            <v-list-item-content>
              <v-list-item-title>{{ route.title }}</v-list-item-title>
            </v-list-item-content>
            <v-list-item-action v-if="route.badge">
              <v-badge
                color="primary"
                inline
                dot
              />
            </v-list-item-action>
          </v-list-item>
          <v-list-group v-else>
            <v-icon
              slot="prependIcon"
              v-text="route.icon"
            />

            <template #activator>
              <v-list-item-title v-text="route.title" />
            </template>

            <div
              v-for="(subItem, subKey) in route.subItems"
              :key="subKey"
            >
              <v-list-item
                link
                :to="subItem.to"
              >
                <v-list-item-title v-text="subItem.title" />
                <v-list-item-icon>
                  <v-icon v-text="subItem.icon" />
                </v-list-item-icon>
              </v-list-item>
            </div>
          </v-list-group>
        </div>
      </v-list>
    </v-navigation-drawer>

    <v-app-bar
      app
    >
      <v-app-bar-nav-icon
        v-if="isAuth"
        @click="drawer = !drawer"
      />

      <div class="d-flex align-center">
        <v-img
          v-if="!drawer || !isAuth"
          alt="Logo"
          class="mr-2"
          contain
          src="@/assets/images/svg/books_icon.svg"
          transition="scale-transition"
          width="40"
          @click="$router.push({ name: authUser ? 'Dashboard' : 'Login' })"
        />
      </div>

      <v-toolbar-title
        v-if="!drawer || !isAuth"
        class="hidden-sm-and-down"
        @click="$router.push({ name: authUser ? 'Dashboard' : 'Login' })"
        v-text="systemTitle"
      />

      <v-spacer />

      <template v-if="isAuth">
        <v-btn
          elevation="2"
          fab
          small
          class="mr-2"
          color="primary"
          v-text="authUser.acronym"
        />

        <v-menu offset-y>
          <template #activator="{ on }">
            <v-btn
              fab
              elevation="0"
              small
              class="mr-2 grey lighten-2"
              v-on="on"
            >
              <v-icon>
                mdi-menu-down
              </v-icon>
            </v-btn>
          </template>
          <v-list dense>
            <v-list-item
              link
              :to="{ name: 'Settings' }"
            >
              <v-list-item-icon class="mr-2">
                <v-icon small>
                  mdi-account-circle
                </v-icon>
              </v-list-item-icon>

              <v-list-item-content>
                <v-list-item-title class="text-left">
                  Profile
                </v-list-item-title>
              </v-list-item-content>
            </v-list-item>

            <v-list-item
              link
              @click="handleLogout"
            >
              <v-list-item-icon class="mr-2">
                <v-icon small>
                  mdi-logout
                </v-icon>
              </v-list-item-icon>

              <v-list-item-content>
                <v-list-item-title class="text-left">
                  Logout
                </v-list-item-title>
              </v-list-item-content>
            </v-list-item>
          </v-list>
        </v-menu>
      </template>

      <template v-else-if="!isAuth">
        <v-btn
          text
          link
          active-class="primary"
          :to="{ name: 'Home' }"
          exact
          class="mr-2"
        >
          Home
        </v-btn>

        <v-btn
          text
          link
          exact
          active-class="primary"
          :to="{ name: 'Login' }"
        >
          Login
        </v-btn>
      </template>
    </v-app-bar>
  </div>
</template>

<script>
// eslint-disable-next-line no-unused-vars
import { mapState, mapActions, mapGetters, mapMutations } from 'vuex'

export default {
  name: 'Navbar',

  data: () => ({
    drawer: null,

    barColor: 'rgba(0, 0, 0, .8), rgba(0, 0, 0, .8)'
  }),

  computed: {
    ...mapState('users', {
      authUser: 'authUser'
    }),

    isAuth () {
      return this.authUser && this.$route.meta.auth
    },

    routes () {
      const level = this.authUser.level

      if (level === 'student') {
        return [
          {
            to: { name: 'Archive' },
            icon: 'mdi-book-open-page-variant',
            title: 'Archive'
          }
        ]
      }

      return [
        {
          to: { name: 'Dashboard' },
          icon: 'mdi-view-dashboard',
          title: 'Reports'
        },
        {
          to: { name: 'Archive' },
          icon: 'mdi-book-open-page-variant',
          title: 'Archive'
        },
        {
          to: { name: 'Students', params: { status: 'pending' } },
          icon: 'mdi-account-group',
          title: 'Students'
        },
        // {
        //   to: { name: 'Tags' },
        //   icon: 'mdi-tag-text',
        //   title: 'Tags'
        // },
        // {
        //   title: 'Categories',
        //   icon: 'mdi-tag-multiple',
        //   sub: true,
        //   subItems: [
        //     {
        //       to: { name: 'Tags' },
        //       icon: 'mdi-tag-text',
        //       title: 'Tags'
        //     },
        //     {
        //       to: { name: 'Subjects' },
        //       icon: 'mdi-octagram-outline',
        //       title: 'Subjects'
        //     }
        //   ]
        // },
        {
          to: { name: 'Backup' },
          icon: 'mdi-backup-restore',
          title: 'Backup/Restore'
        }
      ]
    },

    systemTitle: () => process.env.VUE_APP_TITLE
  },

  methods: {
    ...mapActions('auth', ['clearAuthUser']),

    ...mapMutations('users', {
      SET_STATE_USER: 'SET_STATE'
    }),

    handleLogout () {
      window.localStorage.clear()
      this.$router.push({ name: 'Login' })
      this.SET_STATE_USER({ state: 'authUser', value: null })
    }
  }
}
</script>
